
#pragma warning( disable : 4244 4700 )  

#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "../sdl/sdl.h"


typedef struct
{
	int x,y;
	int off;
	int r,g,b;

}point;



int main(int argc, char *argv[])
{
		int i=0;
		SDL_Surface *screen;
		SDL_Surface *background;

		void Graph(SDL_Surface *, SDL_Surface *);

		/* Seed the random-number generator with current time so that
		* the numbers will be different every time we run.
		*/
		srand( (unsigned)time( NULL ) );


    // Initialize defaults, Video and Audio 
    if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO)==-1)) { 
        printf("Could not initialize SDL: %s.\n", SDL_GetError());
        exit(-1);
    }
    // Initialize the SDL library 
    if( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
        fprintf(stderr,
                "Couldn't initialize SDL: %s\n", SDL_GetError());
        exit(1);
    }
    // Clean up on exit 
    atexit(SDL_Quit);
    //Set Video Mode
    screen = SDL_SetVideoMode(1024, 768, 0, SDL_FULLSCREEN|SDL_SWSURFACE);
    if ( screen == NULL )
		{
        fprintf(stderr, "Couldn't set video mode: %s\n", SDL_GetError());
        exit(1);
    }

		Graph(background, screen);
   
    // Shutdown all subsystems 
    SDL_Quit();
    exit(0);
}

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}

void Graph(SDL_Surface *background, SDL_Surface *screen)
{
	Uint8 *keys;
	SDL_Event event;

	int i=0, j=0;
	int iterat=1500;
	int anim=3;
	float t;
	float ax, bx, cx, dx;
	float ay, by, cy, dy;
	int r,g,b;

	float x,y;

	point pnt[5], spnt[5], epnt[5];
  Uint32 color;

// start values
	spnt[0].x = 50;
	spnt[0].y = 50;
	spnt[0].off=50;
	spnt[0].r = 255;
	spnt[0].g = 0;
	spnt[0].b = 0;

	spnt[1].x = 200;
	spnt[1].y = 200;
	spnt[1].off=200;
	spnt[1].r = 0;
	spnt[1].g = 0;
	spnt[1].b = 255;

	spnt[2].x = 600;
	spnt[2].y = 100;
	spnt[2].off=400;
	spnt[2].r = 0;
	spnt[2].g = 255;
	spnt[2].b = 0;

	spnt[3].x = 400;
	spnt[3].y = 500;
	spnt[3].off=300;
	spnt[3].r = 255;
	spnt[3].g = 255;
	spnt[3].b = 0;

	spnt[4].x = spnt[0].x;
	spnt[4].y = spnt[0].y;
	spnt[4].off=spnt[0].off;
	spnt[4].r = spnt[0].r;
	spnt[4].g = spnt[0].g;
	spnt[4].b = spnt[0].b;



	for(i=0; i<5; i++)
	{
	// current values
		pnt[i].x = spnt[i].x;
		pnt[i].y = spnt[i].y;
		pnt[i].off=spnt[i].off;
		pnt[i].r = spnt[i].r;
		pnt[i].g = spnt[i].g;
		pnt[i].b = spnt[i].b;
	//targetted values (for animation)
		epnt[i].x = spnt[i].x;
		epnt[i].y = spnt[i].y;
		epnt[i].off=spnt[i].off;
		epnt[i].r = spnt[i].r;
		epnt[i].g = spnt[i].g;
		epnt[i].b = spnt[i].b;
	}



	// Main Loop
	while( 1 )
	{
		// Poll for events
		while( SDL_PollEvent( &event ) )
		{
			if ( event.type == SDL_QUIT) exit(0);		
		}
		
		keys = SDL_GetKeyState(NULL);

		//Exit the Game
		if (keys[SDLK_ESCAPE] == SDL_PRESSED) break;

//////////////////////////////////////

    /* Lock the screen for direct access to the pixels */
    if ( SDL_MUSTLOCK(screen) ) {
        if ( SDL_LockSurface(screen) < 0 ) {
            fprintf(stderr, "Can't lock screen: %s\n", SDL_GetError());
            return;
        }
    }

		for(i=0; i<4; i++)
		{
			cx = 3 * (pnt[i].off - pnt[i].x);
			bx = 3 * (pnt[i+1].off - pnt[i].off) - cx;
			ax = pnt[i+1].x - pnt[i].x - cx - bx;
				
				// y-Value of start or end point is the same than of its offset-point
				// so there is used y instead of yoff
				// so we can shorten the following 3 lines:
				// cy = 3 * (pnt[i].y - pnt[i].y);
				// by = 3 * (pnt[i+1].y - pnt[i].y) - cy;
				// ay = pnt[i+1].y - pnt[i].y - cy - by;		

			cy = 0;
			by = 3 * (pnt[i+1].y - pnt[i].y);
			ay = pnt[i+1].y - pnt[i].y - by;	

			for (j=0; j < iterat; j++) // j+=iterat-1 for only start and end points
			{			 
				 t = j / (float)iterat;
				 x = ax * pow(t,3) + bx * pow(t,2) + cx * t + pnt[i].x;
				 y = ay * pow(t,3) + by * pow(t,2) + cy * t + pnt[i].y;

				 r = pnt[i].r * (1-t) + pnt[i+1].r * t;
				 g = pnt[i].g * (1-t) + pnt[i+1].g * t;
				 b = pnt[i].b * (1-t) + pnt[i+1].b * t;

				 color = SDL_MapRGB(screen->format, r , g, b);

				 if ((x > 0) && (x < screen->w) && (y > 0) && (y < screen->h) ) // if pixel is in screen
					putpixel(screen, x, y, color);								// draw it
			}
	
			// animate points
				if      (pnt[i].x < epnt[i].x ) pnt[i].x++; // animate towards endpoint
				else if (pnt[i].x > epnt[i].x ) pnt[i].x--; //    "
				else if (pnt[i].x == epnt[i].x ) epnt[i].x = rand()%screen->w; // set new endpoint

				if      (pnt[i].y < epnt[i].y ) pnt[i].y++; // animate towards endpoint
				else if (pnt[i].y > epnt[i].y ) pnt[i].y--; //    "
				else if (pnt[i].y == epnt[i].y ) epnt[i].y = rand()%screen->h; // set new endpoint

				if      (pnt[i].off < epnt[i].off ) pnt[i].off++; // animate towards endpoint
				else if (pnt[i].off > epnt[i].off ) pnt[i].off--; //    "
				else if (pnt[i].off == epnt[i].off ) epnt[i].off = rand()%screen->h; // set new endpoint

			// set a new color? (on one chanel only)
				if ( (pnt[i].r == epnt[i].r) && (pnt[i].g == epnt[i].g) && (pnt[i].b == epnt[i].b ) ) // set new value for this channel
				{
					switch (rand()%3)
					{
						case 0: rand()%2 ? epnt[i].r=0 : epnt[i].r=255;
								break;
						case 1: rand()%2 ? epnt[i].b=0 : epnt[i].b=255;
								break;
						case 2: rand()%2 ? epnt[i].b=0 : epnt[i].b=255;
								break;
					}
				}
			// color animation
				if      (pnt[i].r < epnt[i].r) pnt[i].r++; // animate towards endpoint
				else if (pnt[i].r > epnt[i].r) pnt[i].r--; //    "
				
				
				if      (pnt[i].g < epnt[i].g) pnt[i].g++; // animate towards endpoint
				else if (pnt[i].g > epnt[i].g) pnt[i].g--; //    "
				
				
				if      (pnt[i].b < epnt[i].b ) pnt[i].b++; // animate towards endpoint
				else if (pnt[i].b > epnt[i].b ) pnt[i].b--; //    "



		}

    if ( SDL_MUSTLOCK(screen) ) {
        SDL_UnlockSurface(screen);
    }
    // Update just the part of the display that we've changed 
    SDL_UpdateRect(screen, 0, 0, 0, 0);

	}


}