
#pragma warning( disable : 4244 4700 )  

#include "exp-zahlen.h"

typedef struct
{
	int x,y;
	int off;
	int r,g,b;
}point;


int main(int argc, char *argv[])
{
	void Graph(SDL_Surface *, SDL_Surface *, int);
	int auswahl;
	SDL_Surface *screen;
	SDL_Surface *background;

	srand( (unsigned)time( NULL ) );

	printf("Caliga's Graph-O-Mat\n\n\n");
	printf("Beenden mit ESC\n\n");
	printf("C, D, Lambda dekrementieren: NUMpad 1, 2, 3\n");
	printf("C, D, Lambda inkrementieren: NUMpad 7, 8, 9\n");
	printf("Groessere Schrittweite mit SHIFT ( * 10 )\n");
	printf("               und mit mit CTRL  ( * 1000 )\n");
	printf("\n\nBitte  Graph waehlen... \n");
	printf("a druecken fuer:   C * (1-D*e^(-l*x))/(1+D*e^(-l*x)\n");
	printf("b druecken fuer:   C * (1-D*e^(-l*x))*(1+D*e^(-l*x)\n");

	do auswahl = getch();
	while ((auswahl!='a')&&(auswahl!='b'));

    // Initialize the SDL library 
    if( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
        fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError()); exit(1); }
	// Clean up on exit 
    atexit(SDL_Quit);
    //Set Video Mode
    screen = SDL_SetVideoMode(1024, 768, 0, SDL_FULLSCREEN|SDL_SWSURFACE);
    if ( screen == NULL )
		{
        fprintf(stderr, "Couldn't set video mode: %s\n", SDL_GetError());
        exit(1);
    }

	Graph(background, screen, auswahl);
   
    // Shutdown all subsystems 
    SDL_Quit();
    exit(0);
}

void Graph(SDL_Surface *background, SDL_Surface *screen, int auswahl)
{
	Uint8 *keys;
	SDL_Event event;
	SDLMod mods;
	int i=0, j=0;
	double C=1.0, D=3.0/2, e=2.7182818284590452353602874713527, l=0.5 * log(2);
	int anim=3;
	float t;
	int r,g,b;
	float y; // x ist j

	SDL_Rect dest;
	point pnt[2], spnt[2], epnt[2];
	Uint32 color;

	double factor, changeVal = 0.01;
	int zahlausgabe = 1;

// start values
	spnt[0].x = 50;
	spnt[0].y = 50;
	spnt[0].off=50;
	spnt[0].r = 255;
	spnt[0].g = 0;
	spnt[0].b = 0;

	spnt[1].x = 200;
	spnt[1].y = 200;
	spnt[1].off=200;
	spnt[1].r = 0;
	spnt[1].g = 0;
	spnt[1].b = 255;



	for(i=0; i<2; i++)
	{
	// current values
		pnt[i].x = spnt[i].x;
		pnt[i].y = spnt[i].y;
		pnt[i].off=spnt[i].off;
		pnt[i].r = spnt[i].r;
		pnt[i].g = spnt[i].g;
		pnt[i].b = spnt[i].b;
	//targetted values (for animation)
		epnt[i].x = spnt[i].x;
		epnt[i].y = spnt[i].y;
		epnt[i].off=spnt[i].off;
		epnt[i].r = spnt[i].r;
		epnt[i].g = spnt[i].g;
		epnt[i].b = spnt[i].b;
	}



	// Main Loop
	while( 1 )
	{
		// Poll for events
		while( SDL_PollEvent( &event ) )
		{
			if ( event.type == SDL_QUIT) exit(0);		
		}
		
		keys = SDL_GetKeyState(NULL);
		mods = SDL_GetModState();

		//Exit the Game
		if (keys[SDLK_ESCAPE] == SDL_PRESSED) break;
		//increase/decrease some values
		if ((mods & KMOD_SHIFT)&&(mods & KMOD_CTRL)) factor = 100000;
		else if (mods & KMOD_SHIFT) factor = 10;
		else if (mods & KMOD_CTRL) factor = 1000;
		else factor = 1;

		if (keys[SDLK_KP1] == SDL_PRESSED) C-=changeVal*factor;
		if (keys[SDLK_KP7] == SDL_PRESSED) C+=changeVal*factor;
		if (keys[SDLK_KP2] == SDL_PRESSED) D-=changeVal*factor;
		if (keys[SDLK_KP8] == SDL_PRESSED) D+=changeVal*factor;
		if (keys[SDLK_KP3] == SDL_PRESSED) l-=changeVal*factor;
		if (keys[SDLK_KP9] == SDL_PRESSED) l+=changeVal*factor;

		if (keys[SDLK_KP4] == SDL_PRESSED)
		{
			zahlausgabe=!zahlausgabe;
			dest.x = 100; dest.y = 10; dest.h = 20; dest.w = 400;
			SDL_FillRect(screen, &dest, 0);
		}
		if (keys[SDLK_KP5] == SDL_PRESSED)
		{
			C=1; D=3.0/2; l=0.5 * log(2);
			SDL_FillRect(screen, NULL, 0); // schwarz
		}
		


//////////////////////////////////////

    /* Lock the screen for direct access to the pixels */
    if ( SDL_MUSTLOCK(screen) ) {
        if ( SDL_LockSurface(screen) < 0 ) {
            fprintf(stderr, "Can't lock screen: %s\n", SDL_GetError());
            return;
        }
    }

	for(i=0; i<2; i++)
	{

		if(i==0)
		{
			for (j=0; j < screen->w; j++) // j+=iterat-1 for only start and end points
			{			 
				t = j / (float)screen->w;
								
				if (auswahl=='a')
				{
					if((D*pow(e, -l*(j/50.0)))!=-1)
						y = screen->h - screen->h/2 *    C* (1-D*pow(e, -l*(j/50.0)))/(1+D*pow(e, -l*(j/50.0)));
				}
				else    y = screen->h - screen->h/2 *    C* (1-D*pow(e, -l*(j/50.0)))*(1+D*pow(e, -l*(j/50.0)));
				//else fprintf(stderr, "nee, -1\n");
				//fprintf(stderr,"b y %lf  D %lf  l %lf  C %lf  e %lf\n", y, D, l, C, e);
				
				r = pnt[i].r * (1-t) + pnt[i+1].r * t;
				g = pnt[i].g * (1-t) + pnt[i+1].g * t;
				b = pnt[i].b * (1-t) + pnt[i+1].b * t;

				color = SDL_MapRGB(screen->format, r , g, b);

				if ((j > 0) && (j < screen->w) && (y > 0) && (y < screen->h) ) // if pixel is in screen
					putpixel(screen, j, y, color);								// draw it
				//else fprintf(stderr,"r %i  x %i  y %lf    w %i   h %i\n", r, j, y, screen->w, screen->h);
			}

			if (zahlausgabe) Zahlenausgabe(screen, C, D, l, color);
		}


		// set a new color? (on one chanel only)
		if ( (pnt[i].r == epnt[i].r) && (pnt[i].g == epnt[i].g) && (pnt[i].b == epnt[i].b ) ) // set new value for this channel
		{
			switch (rand()%3)
			{
			case 0: rand()%2 ? epnt[i].r=0 : epnt[i].r=255;
				break;
			case 1: rand()%2 ? epnt[i].g=0 : epnt[i].g=255;
				break;
			case 2: rand()%2 ? epnt[i].b=0 : epnt[i].b=255;
				break;
			}
			// falls schwarz
			if ( (epnt[i].r == epnt[i].g)&&(epnt[i].r == epnt[i].b)&&(epnt[i].r == 0) )
			{
				switch (rand()%3)
				{
				case 0: epnt[i].r=255; break;
				case 1: epnt[i].g=255; break;
				case 2: epnt[i].b=255; break;
				}			
			}
		}
		// color animation
		if      (pnt[i].r < epnt[i].r) pnt[i].r++; // animate towards endpoint
		else if (pnt[i].r > epnt[i].r) pnt[i].r--; //    "


		if      (pnt[i].g < epnt[i].g) pnt[i].g++; // animate towards endpoint
		else if (pnt[i].g > epnt[i].g) pnt[i].g--; //    "


		if      (pnt[i].b < epnt[i].b ) pnt[i].b++; // animate towards endpoint
		else if (pnt[i].b > epnt[i].b ) pnt[i].b--; //    "



	}

	if ( SDL_MUSTLOCK(screen) ) {
		SDL_UnlockSurface(screen);
	}
    // Update just the part of the display that we've changed 
    SDL_UpdateRect(screen, 0, 0, 0, 0);

	}


}