
#pragma warning( disable : 4244 4700 )  

#define KOEFFS 50
#define Y_STRETCH 1.0
#define SCALE 150.0  // Vergrerung, damit man was sieht...
#define NIX 0

#include "includes.h"

int main(int argc, char *argv[])
{
	void Graph(SDL_Surface *, int *);
	int i, auswahl, koeff[KOEFFS];
	int fullscreen=1;
	SDL_Surface *screen;

	if((argc>1)&&(argv[1][0]== 'n')) fullscreen = 0;

	srand( (unsigned)time( NULL ) );

	printf("Caliga's Graph-O-Mat                 www.caligamedia.de     mail@caligamedia.de\n\n");
	printf("KURZHILFE:              Beenden mit ESC                mehr Hilfe in readme.txt\n");
	printf("c - Clearscreen ein/ausschalten     z - Zahlenausgabe ein/ausschalten\n");
	printf("d - Kurve dicker zeichnen           r - Reset         alle Werte ruecksetzen\n");

	printf("     Werte bearbeiten: (mit shift schnellere Wertaenderung/Skalierung)\n");
	printf("NUMPAD 0...9  - Koeffizient  1 - 10 auswhlen\n");
	printf("NUMPAD + / -  - aktuellen Koeffizient skalieren\n");
	printf("NUMPAD ENTER  - aktuellen Koeffizient ein/ausschalten (mit 0.0 / 1.0 skalieren)\n");
	printf("CURSOR hoch   - aktuellen Koeffizient \"einschalten\" (mit 1.0 skalieren)\n");
	printf("CURSOR runter - aktuellen Koeffizient \"ausschalten\" (mit 0.0 skalieren)\n");
	printf("CURSOR links  - aktuellen Koeffizient wechseln (niedrigeren auswaehlen)\n");
	printf("CURSOR links  - aktuellen Koeffizient wechseln (hheren auswaehlen)\n");
	printf("BILD AUF/AB   - y-Achse skalieren\n");
	printf("     bei gedrueckter STRG-Taste:\n");
	printf("NUMPAD 0...9 - Koeffizient  1 - 10 auswhlen    (11 - 20 mit shift)\n");
	printf("NUMPAD + -   - Verschiebung des aktuellen Koeffizienten (x-Achse) beschleunigen\n");
	printf("CURSOR up/dn - Anzahl der verwendeten/angezeigten Koeffizienten um 10 aendern\n");
	printf("CURSOR li/re - Anzahl der verwendeten/angezeigten Koeffizienten um 1 erhoehen\n");
	printf("BILD  AUF/AB - Zoom (x- und y-Achse skalieren)\n");

	printf("\n               Bitte  Graph waehlen...  (a, b, c druecken)\n");
	printf("a:   sin(x) + 1/3 sin(3x) + 1/5 sin(5x)... (50 Koeff. 1,3,5,7...99)\n");
	printf("b:   sin(x) + 1/2 sin(2x) + 1/3 sin(3x)... (50 Koeff. 1,2,3,4...50)\n");
	printf("c:   20 eigene Koeffizienten zwischen 1 und 100 eingeben (restliche =0)");

	do auswahl = getch();
	while ((auswahl!='a')&&(auswahl!='b')&&(auswahl!='c'));

	for(i=0; i<KOEFFS; i++) koeff[KOEFFS] = 0;

	if      (auswahl == 'a') for (i=0; i<KOEFFS; i++) koeff[i] = i*2+1; // 1, 3, 5, 7, 9, 11, 13, 15, 17, 19...
	else if (auswahl == 'b') for (i=0; i<KOEFFS; i++) koeff[i] = i+1; // 1, 2, 3, 4, 5, 6, 7, 8, 9, 10...
	else
	{
		if (KOEFFS < 20){ printf("internal Error! KOEFFS too small"); exit(-1); }
		printf("\nBitte geben sie 20 Werte (zwischen 1 und 100) gefolgt von Enter ein. \n");
		for(i=0; i<20; i++)
		{
			printf("\n%i. Wert: ", i+1);
			scanf("%i", &koeff[i]);
			if ( (koeff[i] < 1) || (koeff[i] > 100) ) koeff[i] = 1;
			printf(" %i", koeff[i]);
		}
		for(i=20; i<KOEFFS; i++)	koeff[i]= 0;
	}


	// Initialize the SDL library 
	if( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
		fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError()); exit(1); }
	// Clean up on exit 
	atexit(SDL_Quit);
	//Set Video Mode
	if (fullscreen)	screen = SDL_SetVideoMode(1024, 768, 0, SDL_FULLSCREEN|SDL_SWSURFACE);
	else			screen = SDL_SetVideoMode(1024, 768, 0,                SDL_SWSURFACE);
	if ( screen == NULL )
	{
		fprintf(stderr, "Couldn't set video mode: %s\n", SDL_GetError());
		exit(1);
	}

	Graph(screen, koeff);

	// Shutdown all subsystems
	SDL_Quit();
	exit(0);
}

void Graph(SDL_Surface *screen, int *koeff)
{
	void drawline(SDL_Surface *, Uint32, int, int, int, int);

	Uint8 *keys;
	SDL_Event event;
	SDLMod mods;

	SDL_AudioSpec format;
	int samples=SOUND_BUFFER_SIZE / 2;	// 2 byte pro sample
	Sint16 sampleValue;
	int i=0, j=0, k=0;

	int prevpoint_g, prevpoint_g1, prevpoint_g2, prevpoint[KOEFFS];	//letzter y-Wert
	double t;
	double y; // x ist j
	int currentFactor=0;
	int soundupdate=0;

	Uint32 color[KOEFFS], linecolor, sumcolor;

	// zahlenausgeben, clearscreen, reset, toggleMaxMin, left, right, up, down, CTRLleft, CTRLright, CTRLup, CTRLdown, doppeldick, sound, line
	int keyIsPressed[16] = {0};
	int keyAction[16] = {1, 0, NIX, NIX,                  0, 0, NIX, NIX,       0, 0, 0, 0,                           0,0,0}; // NIX: unbenutzt

	double scalingFactor, changeVal = 0.01;
	double factors[KOEFFS];
	double sine[KOEFFS], sines;
	double speed[KOEFFS];    // Geschwindigkeit der Verschiebung auf x-Achse
	double shifting[KOEFFS]; // Verschiebung auf x-Achse

	double y_stretch = Y_STRETCH;	// gesamtskalierung
	double scale = SCALE;

	int usedKoeffs = 10;
	if (usedKoeffs > KOEFFS) usedKoeffs = KOEFFS;

	for(i=0; i < KOEFFS; i++)
	{
		factors[i] = 1;
		speed[i]   = 0;
		shifting[i]= 0;
	}

	// Format: 16 Bit, mono, 44 KHz 
	format.freq = 44100;
	format.format = AUDIO_S16;
	format.channels = 1;
	format.samples = 512;        /* ein guter Wert fr Spiele */
	format.callback = mixeAudio;
	format.userdata = NULL;

	linecolor = SDL_MapRGB(screen->format, 128 , 128, 128);
	sumcolor  = SDL_MapRGB(screen->format, 255, 255, 255);

	for(i=0; i<KOEFFS; i++)
	{
		if ( i<10)	color[i] = SDL_MapRGB(screen->format, 255,       (255/10.0)*(i%10), 0); // rot bis gelb
		else if ( i<20)	color[i] = SDL_MapRGB(screen->format, 255 - (255/10.0)*(i%10), 255, 0); // gelb bis grn
		else if ( i<30)	color[i] = SDL_MapRGB(screen->format,   0, 255,  (255/10.0)*(i%10)); // grn bis hellblau
		else if ( i<40)	color[i] = SDL_MapRGB(screen->format, 0, 255 - (255/10.0)*(i%10), 255); // hellblau bis blau
		else if ( i<50)	color[i] = SDL_MapRGB(screen->format, (255/10.0)*(i%10), 0, 255); // blau bis violett
	}

	// Main Loop
	while( 1 )
	{
		// Poll for events
		while( SDL_PollEvent( &event ) )
		{
			if ( event.type == SDL_QUIT) exit(0);		
		}

		keys = SDL_GetKeyState(NULL);
		mods = SDL_GetModState();

		//Exit the Game
		if (keys[SDLK_ESCAPE] == SDL_PRESSED) break;
		//increase/decrease some values
		if (mods & KMOD_SHIFT) scalingFactor = 10;
		else scalingFactor = 1;
	// C
		if (keys[SDLK_c] == SDL_PRESSED)
		{
			if(! keyIsPressed[clearscreen])
			{
				keyIsPressed[clearscreen] = 1;
				// always clearscreen?
				keyAction[clearscreen] = ! keyAction[clearscreen];
			}
		} else keyIsPressed[clearscreen] = 0;
	// D
		if (keys[SDLK_d] == SDL_PRESSED)
		{
			if(! keyIsPressed[doppeldick])
			{
				keyIsPressed[doppeldick] = 1;
				// gesamtwelle doppelt zeichnen?
				keyAction[doppeldick] = ! keyAction[doppeldick];
			}
		} else keyIsPressed[doppeldick] = 0;
	// L
		if (keys[SDLK_l] == SDL_PRESSED)
		{
			if(! keyIsPressed[line])
			{
				keyIsPressed[line] = 1;
				// Punkte verbinden?
				keyAction[line] = ! keyAction[line];
			}
		} else keyIsPressed[line] = 0;
	// R
		// reset alle Werte
		if (keys[SDLK_r] == SDL_PRESSED)
		{
			if(! keyIsPressed[reset])
			{
				keyIsPressed[reset] = 1;
				// reset ...
				y_stretch = Y_STRETCH;
				scale = SCALE;
				for(i=0; i < KOEFFS; i++)
				{
					factors[i] = 1;
					speed[i]   = 0;
					shifting[i]= 0;
				}
				SDL_FillRect(screen, NULL, 0); // schwarz
				usedKoeffs = 10;
				if (usedKoeffs > KOEFFS) usedKoeffs = KOEFFS;
			}
		} else keyIsPressed[reset] = 0;
	// S
		if (keys[SDLK_s] == SDL_PRESSED)
		{
			if(! keyIsPressed[sound])
			{
				keyIsPressed[sound] = 1;
				// play sound?
				keyAction[sound] = ! keyAction[sound];
				if (keyAction[sound])
				{
					sounds.data = malloc(SOUND_BUFFER_SIZE);
					sounds.dlen = SOUND_BUFFER_SIZE;	
					sounds.dpos = 0;

					/* das Audio-Gert ffnen und das Abspielen beginnen */
					if ( SDL_OpenAudio(&format, NULL) < 0 ) {
						fprintf(stderr, "Audio-Gert konnte nicht geffnet werden: %s\n", SDL_GetError());	exit(1);	}
					SDL_LockAudio();
					for(i=0; i< SOUND_BUFFER_SIZE; i++)	sounds.data[i] = 0;
					SDL_UnlockAudio();
					SDL_PauseAudio(0);					
				}
				else
				{
					SDL_CloseAudio();
					free(sounds.data);
				}
			}
		} else keyIsPressed[sound] = 0;
	// Y/Z
		// toggle Zahlenausgabe
		if (keys[SDLK_y] == SDL_PRESSED)
		{
			if(! keyIsPressed[zahlenausgeben])
			{
				keyIsPressed[zahlenausgeben] = 1;
				// werte ausgeben?
				keyAction[zahlenausgeben] = ! keyAction[zahlenausgeben];
			}
		} else keyIsPressed[zahlenausgeben] = 0;
	// KEYPAD 0-9
		// factor / koeffizient auswhlen
		if (! (mods & KMOD_SHIFT) )
		{
			if (keys[SDLK_KP0] == SDL_PRESSED) currentFactor = 0;
			if (keys[SDLK_KP1] == SDL_PRESSED) currentFactor = 1;
			if (keys[SDLK_KP2] == SDL_PRESSED) currentFactor = 2;
			if (keys[SDLK_KP3] == SDL_PRESSED) currentFactor = 3;
			if (keys[SDLK_KP4] == SDL_PRESSED) currentFactor = 4;
			if (keys[SDLK_KP5] == SDL_PRESSED) currentFactor = 5;
			if (keys[SDLK_KP6] == SDL_PRESSED) currentFactor = 6;
			if (keys[SDLK_KP7] == SDL_PRESSED) currentFactor = 7;
			if (keys[SDLK_KP8] == SDL_PRESSED) currentFactor = 8;
			if (keys[SDLK_KP9] == SDL_PRESSED) currentFactor = 9;
		}
		else
		{
			if(KOEFFS >=20)
			{
				if (keys[SDLK_KP0] == SDL_PRESSED) currentFactor = 10;
				if (keys[SDLK_KP1] == SDL_PRESSED) currentFactor = 11;
				if (keys[SDLK_KP2] == SDL_PRESSED) currentFactor = 12;
				if (keys[SDLK_KP3] == SDL_PRESSED) currentFactor = 13;
				if (keys[SDLK_KP4] == SDL_PRESSED) currentFactor = 14;
				if (keys[SDLK_KP5] == SDL_PRESSED) currentFactor = 15;
				if (keys[SDLK_KP6] == SDL_PRESSED) currentFactor = 16;
				if (keys[SDLK_KP7] == SDL_PRESSED) currentFactor = 17;
				if (keys[SDLK_KP8] == SDL_PRESSED) currentFactor = 18;
				if (keys[SDLK_KP9] == SDL_PRESSED) currentFactor = 19;
			}
		}
	// PG UP/DOWN	 NUM +/-	NUM ENTER
		if (! (mods & KMOD_CTRL) )	// ohne CTRL
		{	// y-Achse skalieren		(bild auf/ab)
			if (keys[SDLK_PAGEUP]   == SDL_PRESSED) y_stretch += changeVal*scalingFactor;
			if (keys[SDLK_PAGEDOWN] == SDL_PRESSED) y_stretch -= changeVal*scalingFactor;
			// aktuellen koeffizienten skalieren		(KP +/-)
			if (keys[SDLK_KP_PLUS]  == SDL_PRESSED) factors[currentFactor] += changeVal*scalingFactor;
			if (keys[SDLK_KP_MINUS] == SDL_PRESSED) factors[currentFactor] -= changeVal*scalingFactor;

			// toggle currentFactor 1 / 0 toggleMaxMin
			if (keys[SDLK_KP_ENTER] == SDL_PRESSED)
			{
				if(! keyIsPressed[toggleMaxMin])
				{
					keyIsPressed[toggleMaxMin] = 1;
					// factors[] auf 1 / -1 oder auf 0 setzen?
					if      (factors[currentFactor]  > 0) factors[currentFactor] =  0.0;
					else if (factors[currentFactor] == 0) factors[currentFactor] = -1.0;
					else								  factors[currentFactor] =  1.0;
				}
			} else keyIsPressed[toggleMaxMin] = 0;
		}
		else	// mit CTRL
		{	// skalieren	(bild auf/ab)
			if (keys[SDLK_PAGEUP] == SDL_PRESSED) scale += changeVal*100*scalingFactor;
			if (keys[SDLK_PAGEDOWN] == SDL_PRESSED) scale -= changeVal*100*scalingFactor;
			// bewegen		(KP +/-)
			if (keys[SDLK_KP_PLUS]  == SDL_PRESSED) speed[currentFactor] += changeVal*scalingFactor;
			if (keys[SDLK_KP_MINUS] == SDL_PRESSED) speed[currentFactor] -= changeVal*scalingFactor;

			// toggle currentFactor 1 / 0 toggleMaxMin
			if (keys[SDLK_KP_ENTER] == SDL_PRESSED)
			{
				if(! keyIsPressed[toggleMaxMin])
				{
					keyIsPressed[toggleMaxMin] = 1;
					// speed[] auf 0 setzen
					speed[currentFactor] = 0;
				}
			} else keyIsPressed[toggleMaxMin] = 0;
		}

		//cursor keys:  aktuellen koeffizienten wechseln / auf 1/0 setzen
		if (! (mods & KMOD_CTRL) )
		{
			if (keys[SDLK_LEFT] == SDL_PRESSED)
			{
				if(! keyIsPressed[left])
				{
					keyIsPressed[left] = 1;
					if (currentFactor > 0) currentFactor--;
				}
			} else keyIsPressed[left] = 0;

			if (keys[SDLK_RIGHT] == SDL_PRESSED)
			{
				if(! keyIsPressed[right])
				{
					keyIsPressed[right] = 1;
					if (currentFactor < KOEFFS-1) currentFactor++;
				}
			} else keyIsPressed[right] = 0;

			if (keys[SDLK_UP] == SDL_PRESSED)	factors[currentFactor] = 1.0;
			if (keys[SDLK_DOWN] == SDL_PRESSED)	factors[currentFactor] = 0.0;
		}
		else // anzahl verwendeter koeffizienten wechseln
		{
			if (keys[SDLK_LEFT] == SDL_PRESSED)
			{
				if(! keyIsPressed[CTRLleft])
				{
					keyIsPressed[CTRLleft] = 1;
					if(usedKoeffs > 0) usedKoeffs--;
				}
			} else keyIsPressed[CTRLleft] = 0;

			if (keys[SDLK_RIGHT] == SDL_PRESSED)
			{
				if(! keyIsPressed[CTRLright])
				{
					keyIsPressed[CTRLright] = 1;
					if(usedKoeffs < KOEFFS) usedKoeffs++;
				}
			} else keyIsPressed[CTRLright] = 0;

			if (keys[SDLK_UP] == SDL_PRESSED)
			{
				if(! keyIsPressed[CTRLup])
				{
					keyIsPressed[CTRLup] = 1;
					if(usedKoeffs <= KOEFFS-10) usedKoeffs+=10;
				}
			} else keyIsPressed[CTRLup] = 0;

			if (keys[SDLK_DOWN] == SDL_PRESSED)
			{
				if(! keyIsPressed[CTRLdown])
				{
					keyIsPressed[CTRLdown] = 1;
					if(usedKoeffs >= 10) usedKoeffs-=10;
				}
			} else keyIsPressed[CTRLdown] = 0;
		}
		//////////////////////////////////////

		// Bewegung der Sinen:

		for(i=0; i < KOEFFS; i++)	shifting[i]+= speed[i];


		/* Lock the screen for direct access to the pixels */
		if ( SDL_MUSTLOCK(screen) ) {
			if ( SDL_LockSurface(screen) < 0 ) {
				fprintf(stderr, "Can't lock screen: %s\n", SDL_GetError());
				return;
			}
		}

		if (keyAction[clearscreen]) SDL_FillRect(screen, NULL, 0); // schwarz

		for (j=1; j < screen->w; j++) // j+=iterat-1 for only start and end points
		{			 
			// Null-Linie
			y = screen->h/2;	if(!(j%10)) putpixel(screen, j, y, linecolor);	

			// Grenzen
			y = screen->h/2 + scale * y_stretch;
			if(!(j%10))	if ( (y > 0) && (y < screen->h) ) putpixel(screen, j, y, linecolor);
			y = screen->h/2 - scale * y_stretch;
			if(!(j%10))	if ( (y > 0) && (y < screen->h) ) putpixel(screen, j, y, linecolor);

			if (!(keyAction[line]))
			{
				// KOEFFS Kurven (Graph)
				sines = 0;
				for (k=0; k < usedKoeffs; k++)
				{
					sine[k] = factors[k] * 1.0/koeff[k] * sin(koeff[k]*j/scale - shifting[k]);
					y = screen->h/2 - scale * y_stretch * sine[k];
					if ( (y > 0) && (y < screen->h) ) putpixel(screen, j, y, color[k]);

					sines += sine[k];
				}

				// Gesamtkurve
				y = screen->h/2 - scale * y_stretch * sines;
				if ( (y > 0) && (y < screen->h) ) putpixel(screen, j, y, sumcolor);

				// Gesamtkurve dicker?
				if(keyAction[doppeldick])
				{
					y = screen->h/2 - 1 - scale * y_stretch * sines;
					if ( (y > 0) && (y < screen->h) ) putpixel(screen, j, y, sumcolor);
					y = screen->h/2 + 1 - scale * y_stretch * sines;
					if ( (y > 0) && (y < screen->h) ) putpixel(screen, j, y, sumcolor);

				}
			}
			else // Punkte verbinden
			{
				// KOEFFS Kurven (Graph)
				sines = 0;
				for (k=0; k < usedKoeffs; k++)
				{
					sine[k] = factors[k] * 1.0/koeff[k] * sin(koeff[k]*j/scale - shifting[k]);
					y = screen->h/2 - scale * y_stretch * sine[k];
					//spassig... if(j!=1) drawline(screen, color[k], j-1, prevpoint_g, 1, y-prevpoint_g);
					if(j!=1) drawline(screen, color[k], j-1, prevpoint[k], 1, y-prevpoint[k]);

					sines += sine[k];
					prevpoint[k] = y;
				}

				// Gesamtkurve
				y = screen->h/2 - scale * y_stretch * sines;
				if(j!=1) drawline(screen, sumcolor, j-1, prevpoint_g, 1, y-prevpoint_g);
				prevpoint_g = y;

				// Gesamtkurve dicker?
				if(keyAction[doppeldick])
				{
					y = screen->h/2 - 1 - scale * y_stretch * sines;
					if(j!=1) drawline(screen, sumcolor, j-1, prevpoint_g1, 1, y-prevpoint_g1);
					prevpoint_g1 = y;
					y = screen->h/2 + 1 - scale * y_stretch * sines;
					if(j!=1) drawline(screen, sumcolor, j-1, prevpoint_g2, 1, y-prevpoint_g2);
					prevpoint_g2 = y;
				}
			}
		} // for ()

		if ( keyAction[zahlenausgeben] ) Zahlenausgabe(screen, y_stretch, scale, usedKoeffs, currentFactor, factors, speed);
		soundupdate++;
		if (keyAction[sound])
		{
			if(! (soundupdate%10))
			{
				SDL_LockAudio();
				for(j=0; j < samples; j++) // 1024 durchlufe fr SOUND_BUFFER_SIZE = 2048
				{
					t = 2 * M_PI * ((double)j/ samples) ;
					// KOEFFS Kurven (Sound)
					sines = 0;
					for (k=0; k < usedKoeffs; k++)
					{
						//sine[k] = factors[k] * 1.0/koeff[k] * sin(koeff[k]*t - shifting[k]);
						// fr nicht stehende wellen!?!
						sine[k] = factors[k] * 1.0/koeff[k] * sin(koeff[k]*t - shifting[k] - (j*speed[k])/40);
						if     (sine[k] >  1.0) sine[k] = 1.0;
						else if(sine[k] < -1.0) sine[k] = -1.0;
						sines += sine[k];
					}

					// wg multiplikation mit (32768/10)
					if     (sines >  10.0) sines = 10.0;
					else if(sines < -10.0) sines = -10.0;

					sampleValue = sines * (32768/10);

					sounds.data[j*2]   =  sampleValue       & 0xff;
					sounds.data[j*2+1] = (sampleValue >> 8) & 0xff;
					
					//sounds.data[j*2]    = 0 ;
					//sounds.data[j*2+1]    = 0 ;
					//printf("%i\n", 128 - ((j%2)*2 -1)* 30);
				}
				/* // test
				for(i=0; i< SOUND_BUFFER_SIZE; i++)
				{
				if (i%100 < 50)
				{
				switch(i%2)
				{
				case 1:		sounds.data[i] = 0; break;
				case 0:		sounds.data[i] = 30; break;
				}
				}
				else
				{
				switch(i%2)
				{
				case 1:		sounds.data[i] = 0; break;
				case 0:		sounds.data[i] = -30; break;
				}
				}
				}

				*/

				SDL_UnlockAudio();

			}
		}


		if ( SDL_MUSTLOCK(screen) ) {
			SDL_UnlockSurface(screen);
		}
		// Update just the part of the display that we've changed 
		SDL_UpdateRect(screen, 0, 0, 0, 0);

	} // main loop
}


void drawline(SDL_Surface *screen, Uint32 color, int x, int y, int w, int h)
{
	// achtung! nur ypos wird auf gltigkeit geprft!
	int i, ypos, xpos;
	if (h<0)
	{
		y+=h;
		h*=-1;
	}
	if(h>w)	// vergleich der betrge
	{
		for(i=0; i<h; i++)
		{
			xpos=x+((double)w/h)*i;
			ypos=y+i;
			if ((ypos>0)&&(ypos<screen->h)) putpixel(screen, xpos, ypos, color);
		}
	}
	else
	{
		for(i=0; i<w; i++)
		{
			ypos=y+((double)h/w)*i;
			if ((ypos>0)&&(ypos<screen->h)) putpixel(screen, x+i, ypos, color);
		}
	}
}